Skip to content

Instance Pool

Instance Pools is an Exoscale service allowing users to provision managed groups of identical Compute instances automatically.

Read more

create-instance-pool

Create an Instance Pool

POST /instance-pool

Request body

Content-Type: application/json

PropertyTypeRequiredDescription
disk-sizeintegeryesInstances disk size in GiB
instance-typeInstance type referenceyesInstances type
namestringyesInstance Pool name
sizeintegeryesNumber of Instances
templateTemplate referenceyesInstances template
anti-affinity-groupsarray of Anti-affinity group referencenoInstance Pool Anti-affinity Groups
application-consistent-snapshot-enabledbooleannoEnable application consistent snapshots
deploy-targetDeploy target referencenoDeploy Target to deploy Instances on
descriptionstringnoInstance Pool description
elastic-ipsarray of Elastic IP referencenoInstances Elastic IPs
instance-prefixstringnoPrefix to apply to Instances names (default: pool)
ipv6-enabledbooleannoEnable IPv6. DEPRECATED: use public-ip-assignments.
labelsobjectnoInstance Pool Labels
min-availableintegernoMinimum number of running Instances
private-networksarray of Private network referencenoInstance Pool Private Networks
public-ip-assignmentstringnoDetermines public IP assignment of the Instances. Type none is final and can’t be changed later on.

Allowed values: inet4, dual, none.
security-groupsarray of Security group referencenoInstance Pool Security Groups
ssh-keySSH key referencenoInstances SSH key
ssh-keysarray of SSH key referencenoInstances SSH Keys
user-datastringnoInstances Cloud-init user-data
Example
{
  "anti-affinity-groups": [
    {
      "id": "string"
    }
  ],
  "application-consistent-snapshot-enabled": true,
  "deploy-target": {
    "id": "string"
  },
  "description": "string",
  "disk-size": 0,
  "elastic-ips": [
    {
      "id": "string"
    }
  ],
  "instance-prefix": "string",
  "instance-type": {
    "id": "string"
  },
  "ipv6-enabled": true,
  "labels": {},
  "min-available": 0,
  "name": "string",
  "private-networks": [
    {
      "id": "string"
    }
  ],
  "public-ip-assignment": "inet4",
  "security-groups": [
    {
      "id": "string"
    }
  ],
  "size": 0,
  "ssh-key": {
    "name": "string"
  },
  "ssh-keys": [
    {
      "name": "string"
    }
  ],
  "template": {
    "id": "string"
  },
  "user-data": "string"
}

Responses

Status: 200 - 200

Content-Type: application/json

PropertyTypeDescription
idstringOperation ID
messagestringOperation message
reasonstringOperation failure reason

Allowed values: incorrect, unknown, unavailable, forbidden, busy, fault, partial, not-found, interrupted, unsupported, conflict.
referenceReferenceRelated resource reference
statestringOperation status

Allowed values: failure, pending, success, timeout.
Example output
{
  "id": "string",
  "message": "string",
  "reason": "incorrect",
  "reference": {
    "command": "string",
    "id": "string",
    "link": "string"
  },
  "state": "failure"
}

SDK reference for create-instance-pool: golang | Python | Java

CLI: exo api create-instance-pool

get-instance-pool

Retrieve Instance Pool details

GET /instance-pool/{id}

Path parameters

NameInDescription
idpath

Responses

Status: 200 - 200

Content-Type: application/json

PropertyTypeDescription
anti-affinity-groupsarray of Anti-affinity group referenceInstance Pool Anti-affinity Groups
application-consistent-snapshot-enabledbooleanEnable application consistent snapshots
deploy-targetDeploy target referenceInstance Pool Deploy Target
descriptionstringInstance Pool description
disk-sizeintegerInstances disk size in GiB
elastic-ipsarray of Elastic IP referenceInstances Elastic IPs
idstringInstance Pool ID
instance-prefixstringThe instances created by the Instance Pool will be prefixed with this value (default: pool)
instance-typeInstance type referenceInstances type
instancesarray of Target InstanceInstances
ipv6-enabledbooleanEnable IPv6 for instances
labelsobjectInstance Pool Labels
managerResource managerInstance Pool manager
min-availableintegerMinimum number of running instances
namestringInstance Pool name
private-networksarray of Private network referenceInstance Pool Private Networks
public-ip-assignmentstringInstance Pool public IP assignment

Allowed values: inet4, dual, none.
security-groupsarray of Security group referenceInstance Pool Security Groups
sizeintegerNumber of instances
ssh-keySSH key referenceInstances SSH key
ssh-keysarray of SSH key referenceInstances SSH keys
statestringInstance Pool state

Allowed values: scaling-up, scaling-down, destroying, creating, suspended, running, updating.
templateTemplate referenceInstances template
user-datastringInstances Cloud-init user-data
Example output
{
  "anti-affinity-groups": [
    {
      "id": "string"
    }
  ],
  "application-consistent-snapshot-enabled": true,
  "deploy-target": {
    "id": "string"
  },
  "description": "string",
  "disk-size": 0,
  "elastic-ips": [
    {
      "id": "string"
    }
  ],
  "id": "string",
  "instance-prefix": "string",
  "instance-type": {
    "id": "string"
  },
  "instances": [
    {
      "id": "string"
    }
  ],
  "ipv6-enabled": true,
  "labels": {},
  "manager": {
    "id": "string",
    "type": "sks-nodepool"
  },
  "min-available": 0,
  "name": "string",
  "private-networks": [
    {
      "id": "string"
    }
  ],
  "public-ip-assignment": "inet4",
  "security-groups": [
    {
      "id": "string"
    }
  ],
  "size": 0,
  "ssh-key": {
    "name": "string"
  },
  "ssh-keys": [
    {
      "name": "string"
    }
  ],
  "state": "scaling-up",
  "template": {
    "id": "string"
  },
  "user-data": "string"
}

SDK reference for get-instance-pool: golang | Python | Java

CLI: exo api get-instance-pool

scale-instance-pool

Scale an Instance Pool

PUT /instance-pool/{id}:scale

Path parameters

NameInDescription
idpath

Request body

Content-Type: application/json

PropertyTypeRequiredDescription
sizeintegeryesNumber of managed Instances
Example
{
  "size": 0
}

Responses

Status: 200 - 200

Content-Type: application/json

PropertyTypeDescription
idstringOperation ID
messagestringOperation message
reasonstringOperation failure reason

Allowed values: incorrect, unknown, unavailable, forbidden, busy, fault, partial, not-found, interrupted, unsupported, conflict.
referenceReferenceRelated resource reference
statestringOperation status

Allowed values: failure, pending, success, timeout.
Example output
{
  "id": "string",
  "message": "string",
  "reason": "incorrect",
  "reference": {
    "command": "string",
    "id": "string",
    "link": "string"
  },
  "state": "failure"
}

SDK reference for scale-instance-pool: golang | Python | Java

CLI: exo api scale-instance-pool

update-instance-pool

Update an Instance Pool

PUT /instance-pool/{id}

Path parameters

NameInDescription
idpath

Request body

Content-Type: application/json

PropertyTypeRequiredDescription
anti-affinity-groupsarray of Anti-affinity group referencenoInstance Pool Anti-affinity Groups
application-consistent-snapshot-enabledbooleannoEnable application consistent snapshots
deploy-targetDeploy target referencenoInstance Pool Deploy Target
descriptionstringnoInstance Pool description
disk-sizeintegernoInstances disk size in GiB
elastic-ipsarray of Elastic IP referencenoInstances Elastic IPs
instance-prefixstringnoPrefix to apply to Instances names (default: pool)
instance-typeInstance type referencenoInstances type
ipv6-enabledbooleannoEnable IPv6. DEPRECATED: use public-ip-assignments.
labelsobjectnoInstance Pool Labels
min-availableintegernoMinimum number of running Instances
namestringnoInstance Pool name
private-networksarray of Private network referencenoInstance Pool Private Networks
public-ip-assignmentstringnoDetermines public IP assignment of the Instances.

Allowed values: inet4, dual.
security-groupsarray of Security group referencenoInstance Pool Security Groups
ssh-keySSH key referencenoInstances SSH key
ssh-keysarray of SSH key referencenoInstances SSH keys
templateTemplate referencenoInstances template
user-datastringnoInstances Cloud-init user-data
Example
{
  "anti-affinity-groups": [
    {
      "id": "string"
    }
  ],
  "application-consistent-snapshot-enabled": true,
  "deploy-target": {
    "id": "string"
  },
  "description": "string",
  "disk-size": 0,
  "elastic-ips": [
    {
      "id": "string"
    }
  ],
  "instance-prefix": "string",
  "instance-type": {
    "id": "string"
  },
  "ipv6-enabled": true,
  "labels": {},
  "min-available": 0,
  "name": "string",
  "private-networks": [
    {
      "id": "string"
    }
  ],
  "public-ip-assignment": "inet4",
  "security-groups": [
    {
      "id": "string"
    }
  ],
  "ssh-key": {
    "name": "string"
  },
  "ssh-keys": [
    {
      "name": "string"
    }
  ],
  "template": {
    "id": "string"
  },
  "user-data": "string"
}

Responses

Status: 200 - 200

Content-Type: application/json

PropertyTypeDescription
idstringOperation ID
messagestringOperation message
reasonstringOperation failure reason

Allowed values: incorrect, unknown, unavailable, forbidden, busy, fault, partial, not-found, interrupted, unsupported, conflict.
referenceReferenceRelated resource reference
statestringOperation status

Allowed values: failure, pending, success, timeout.
Example output
{
  "id": "string",
  "message": "string",
  "reason": "incorrect",
  "reference": {
    "command": "string",
    "id": "string",
    "link": "string"
  },
  "state": "failure"
}

SDK reference for update-instance-pool: golang | Python | Java

CLI: exo api update-instance-pool

delete-instance-pool

Delete an Instance Pool

DELETE /instance-pool/{id}

Path parameters

NameInDescription
idpath

Responses

Status: 200 - 200

Content-Type: application/json

PropertyTypeDescription
idstringOperation ID
messagestringOperation message
reasonstringOperation failure reason

Allowed values: incorrect, unknown, unavailable, forbidden, busy, fault, partial, not-found, interrupted, unsupported, conflict.
referenceReferenceRelated resource reference
statestringOperation status

Allowed values: failure, pending, success, timeout.
Example output
{
  "id": "string",
  "message": "string",
  "reason": "incorrect",
  "reference": {
    "command": "string",
    "id": "string",
    "link": "string"
  },
  "state": "failure"
}

SDK reference for delete-instance-pool: golang | Python | Java

CLI: exo api delete-instance-pool


Other Operations

evict-instance-pool-members

Evict Instance Pool members

PUT /instance-pool/{id}:evict

This operation evicts the specified Compute instances member from the Instance Pool, shrinking it to <current pool size> - <# evicted members>.

Path parameters

NameInDescription
idpath

Request body

Content-Type: application/json

PropertyTypeRequiredDescription
instancesarray[string]no
Example
{
  "instances": [
    "string"
  ]
}

Responses

Status: 200 - 200

Content-Type: application/json

PropertyTypeDescription
idstringOperation ID
messagestringOperation message
reasonstringOperation failure reason

Allowed values: incorrect, unknown, unavailable, forbidden, busy, fault, partial, not-found, interrupted, unsupported, conflict.
referenceReferenceRelated resource reference
statestringOperation status

Allowed values: failure, pending, success, timeout.
Example output
{
  "id": "string",
  "message": "string",
  "reason": "incorrect",
  "reference": {
    "command": "string",
    "id": "string",
    "link": "string"
  },
  "state": "failure"
}

SDK reference for evict-instance-pool-members: golang | Python | Java

CLI: exo api evict-instance-pool-members

reset-instance-pool-field

Reset an Instance Pool field to its default value

DELETE /instance-pool/{id}/{field}

Path parameters

NameInDescription
idpath
fieldpath

Responses

Status: 200 - 200

Content-Type: application/json

PropertyTypeDescription
idstringOperation ID
messagestringOperation message
reasonstringOperation failure reason

Allowed values: incorrect, unknown, unavailable, forbidden, busy, fault, partial, not-found, interrupted, unsupported, conflict.
referenceReferenceRelated resource reference
statestringOperation status

Allowed values: failure, pending, success, timeout.
Example output
{
  "id": "string",
  "message": "string",
  "reason": "incorrect",
  "reference": {
    "command": "string",
    "id": "string",
    "link": "string"
  },
  "state": "failure"
}

SDK reference for reset-instance-pool-field: golang | Python | Java

CLI: exo api reset-instance-pool-field

list-instance-pools

List Instance Pools

GET /instance-pool

Responses

Status: 200 - 200

Content-Type: application/json

PropertyTypeDescription
instance-poolsarray of Instance Pool
Example output
{
  "instance-pools": [
    {
      "anti-affinity-groups": [
        {
          "id": "string"
        }
      ],
      "application-consistent-snapshot-enabled": true,
      "deploy-target": {
        "id": "string"
      },
      "description": "string",
      "disk-size": 0,
      "elastic-ips": [
        {
          "id": "string"
        }
      ],
      "id": "string",
      "instance-prefix": "string",
      "instance-type": {
        "id": "string"
      },
      "instances": [
        {
          "id": "string"
        }
      ],
      "ipv6-enabled": true,
      "labels": {},
      "manager": {
        "id": "string",
        "type": "sks-nodepool"
      },
      "min-available": 0,
      "name": "string",
      "private-networks": [
        {
          "id": "string"
        }
      ],
      "public-ip-assignment": "inet4",
      "security-groups": [
        {
          "id": "string"
        }
      ],
      "size": 0,
      "ssh-key": {
        "name": "string"
      },
      "ssh-keys": [
        {
          "name": "string"
        }
      ],
      "state": "scaling-up",
      "template": {
        "id": "string"
      },
      "user-data": "string"
    }
  ]
}

SDK reference for list-instance-pools: golang | Python | Java

CLI: exo api list-instance-pools

Last updated on